import {AppComponent} from './app.component';
import {async, ComponentFixture, TestBed} from '@angular/core/testing';
import {FormsModule} from '@angular/forms';
import {InputComponentManagerService} from './input-component-manager.service';
import {Step} from './step';
import {VersionComponent} from './version/version.component';
import {ConverterSelectorComponent} from './converter-selector/converter-selector.component';
import {TextInputFieldComponent} from './text-input-field/text-input-field.component';
import {ErrorMessageComponent} from './error-message/error-message.component';
import createSpyObj = jasmine.createSpyObj;

describe('AppComponent', () => {
  let sut: AppComponent;
  let fixture: ComponentFixture<AppComponent>;
  const firstStep: Step = new Step(0);

  const inputComponentManagerServiceStub = createSpyObj(['getFirst']);
  inputComponentManagerServiceStub.getFirst.and.returnValue(firstStep);

  const converterRegistryServiceStub = createSpyObj(['getAllConverters', 'getConverter']);
  converterRegistryServiceStub.getAllConverters.and.returnValue([]);
  converterRegistryServiceStub.getConverter.and.returnValue(undefined);

  beforeEach(async(() => {
    TestBed.configureTestingModule({
      declarations: [
        AppComponent,
        ConverterSelectorComponent,
        ErrorMessageComponent,
        TextInputFieldComponent,
        VersionComponent
      ],
      imports: [FormsModule],
      providers: [
        {provide: InputComponentManagerService, useValue: inputComponentManagerServiceStub}
      ]
    })
      .compileComponents();
  }));

  beforeEach(() => {
    fixture = TestBed.createComponent(AppComponent);
    sut = fixture.componentInstance;
  });

  it('should create the app', async(() => {
    // const fixture = TestBed.createComponent(AppComponent);
    const app = fixture.debugElement.componentInstance;
    expect(app).toBeTruthy();
  }));
});
